<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Symbol</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Symbol<br/>
<small>
[<a class="el" href="group__m17nCore.html">CORE API</a>]</small>
</h1>
<p>Symbol objects and API for them.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Typedefs</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct MSymbolStruct *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Type of symbols.  <a href="#ga0f53a95817f0b5c26442f8e12f89c16d"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1">msymbol</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a symbol.  <a href="#ga0f19d07c2dd83d37705ca628caaf8cd1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga48e392412c68f18ce58ec0af642d0db5">msymbol_as_managing_key</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create a managing key.  <a href="#ga48e392412c68f18ce58ec0af642d0db5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#gae590d761113d7bd7a687dbb39ac97c54">msymbol_is_managing_key</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Check if a symbol is a managing key.  <a href="#gae590d761113d7bd7a687dbb39ac97c54"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553">msymbol_exist</a> (const char *name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Search for a symbol that has a specified name.  <a href="#ga45a60105ebaeb9c0a9c36d84acd87553"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b">msymbol_name</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get symbol name.  <a href="#ga551d4628363900cad49a908b598b821b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c">msymbol_put</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the value of a symbol property.  <a href="#ga9b90027677f183f65d85dac0d7d5bb9c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527">msymbol_get</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the value of a symbol property.  <a href="#ga62c1ccf5b0a9924061d3a596ae312527"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#gaf0e0b5b8e6e0702ed87df88ad642d7f7">msymbol_put_func</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, <a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a> func)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the value (function pointer) of a symbol property.  <a href="#gaf0e0b5b8e6e0702ed87df88ad642d7f7"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga6446566f8f6a53e825cea16ffbf4c3bd">msymbol_get_func</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the value (function pointer) of a symbol property.  <a href="#ga6446566f8f6a53e825cea16ffbf4c3bd"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb">Mnil</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "nil".  <a href="#ga0346fc05efcccc8f11271b51c0fe3eeb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f">Mt</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "t".  <a href="#ga8769a573efbb023b4d77f9d03babc09f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5">Mstring</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "string".  <a href="#ga60daf7d600a1f487862366a37c171ce5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb">Msymbol</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "symbol".  <a href="#ga6592d4eb3c46fe7fb8993c252b8fedeb"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Symbol objects and API for them. </p>
<p>The m17n library uses objects called <em>symbols</em> as unambiguous identifiers. Symbols are similar to atoms in the X library, but a symbol can have zero or more <em>symbol</em> <em>properties</em>. A symbol property consists of a <em>key</em> and a <em>value</em>, where key is also a symbol and value is anything that can be cast to <code>(void *)</code>. "The symbol property that belongs to the symbol S and
    whose key is K" may be shortened to "K property of S".</p>
<p>Symbols are used mainly in the following three ways.</p>
<ul>
<li>As keys of symbol properties and other properties.</li>
</ul>
<ul>
<li>To represent various objects, e.g. charsets, coding systems, fontsets.</li>
</ul>
<ul>
<li>As arguments of the m17n library functions to control their behavior.</li>
</ul>
<p>There is a special kind of symbol, a <em>managing</em> <em>key</em>. The value of a property whose key is a managing key must be a <em>managed</em> <em>object</em>. See <a class="el" href="group__m17nObject.html">Managed Object</a> for the detail. </p>
<hr/><h2>Typedef Documentation</h2>
<a class="anchor" id="ga0f53a95817f0b5c26442f8e12f89c16d"></a><!-- doxytag: member="m17n&#45;core.h::MSymbol" ref="ga0f53a95817f0b5c26442f8e12f89c16d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct MSymbolStruct* <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Type of symbols. </p>
<p>The type <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d" title="Type of symbols.">MSymbol</a> is for a <em>symbol</em> object. Its internal structure is concealed from application programs. </p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ga0f19d07c2dd83d37705ca628caaf8cd1"></a><!-- doxytag: member="symbol.c::msymbol" ref="ga0f19d07c2dd83d37705ca628caaf8cd1" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> msymbol </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a symbol. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="Get a symbol.">msymbol()</a> function returns the canonical symbol whose name is <b>name</b>. If there is none, one is created. The created one is not a managing key.</p>
<p>Symbols whose name starts by two spaces are reserved by the m17n library, and are used by the library only internally.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>This function returns the found or created symbol.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>This function never fails.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga48e392412c68f18ce58ec0af642d0db5" title="Create a managing key.">msymbol_as_managing_key()</a>, <a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b" title="Get symbol name.">msymbol_name()</a>, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="Search for a symbol that has a specified name.">msymbol_exist()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga48e392412c68f18ce58ec0af642d0db5"></a><!-- doxytag: member="symbol.c::msymbol_as_managing_key" ref="ga48e392412c68f18ce58ec0af642d0db5" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> msymbol_as_managing_key </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Create a managing key. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga48e392412c68f18ce58ec0af642d0db5" title="Create a managing key.">msymbol_as_managing_key()</a> function returns a newly created managing key whose name is <b>name</b>. It there already exists a symbol of name <b>name</b>, it returns <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>.</p>
<p>Symbols whose name starts by two spaces are reserved by the m17n library, and are used by the library only internally.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, this function returns the created symbol. Otherwise, it returns <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>MERROR_SYMBOL</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="Get a symbol.">msymbol()</a>, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="Search for a symbol that has a specified name.">msymbol_exist()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gae590d761113d7bd7a687dbb39ac97c54"></a><!-- doxytag: member="symbol.c::msymbol_is_managing_key" ref="gae590d761113d7bd7a687dbb39ac97c54" args="(MSymbol symbol)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int msymbol_is_managing_key </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Check if a symbol is a managing key. </p>
<p>The <a class="el" href="group__m17nSymbol.html#gae590d761113d7bd7a687dbb39ac97c54" title="Check if a symbol is a managing key.">msymbol_is_managing_key()</a> function checks if the symbol <b>symbol</b> is a managing key or not.</p>
<dl class="user"><dt><b>Return value: </b></dt><dd>Return 1 if the symbol is a managing key. Otherwise, return 0. </dd></dl>

</div>
</div>
<a class="anchor" id="ga45a60105ebaeb9c0a9c36d84acd87553"></a><!-- doxytag: member="symbol.c::msymbol_exist" ref="ga45a60105ebaeb9c0a9c36d84acd87553" args="(const char *name)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> msymbol_exist </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Search for a symbol that has a specified name. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="Search for a symbol that has a specified name.">msymbol_exist()</a> function searches for the symbol whose name is <b>name</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If such a symbol exists, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="Search for a symbol that has a specified name.">msymbol_exist()</a> returns that symbol. Otherwise it returns the predefined symbol <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd>This function never fails. </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b" title="Get symbol name.">msymbol_name()</a>, <a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="Get a symbol.">msymbol()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga551d4628363900cad49a908b598b821b"></a><!-- doxytag: member="symbol.c::msymbol_name" ref="ga551d4628363900cad49a908b598b821b" args="(MSymbol symbol)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char* msymbol_name </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get symbol name. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga551d4628363900cad49a908b598b821b" title="Get symbol name.">msymbol_name()</a> function returns a pointer to a string containing the name of <b>symbol</b>.</p>
<dl class="user"><dt><b>Errors:</b></dt><dd>This function never fails. </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga0f19d07c2dd83d37705ca628caaf8cd1" title="Get a symbol.">msymbol()</a>, <a class="el" href="group__m17nSymbol.html#ga45a60105ebaeb9c0a9c36d84acd87553" title="Search for a symbol that has a specified name.">msymbol_exist()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga9b90027677f183f65d85dac0d7d5bb9c"></a><!-- doxytag: member="symbol.c::msymbol_put" ref="ga9b90027677f183f65d85dac0d7d5bb9c" args="(MSymbol symbol, MSymbol key, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int msymbol_put </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the value of a symbol property. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="Set the value of a symbol property.">msymbol_put()</a> function assigns <b>val</b> to the value of the symbol property that belongs to <b>symbol</b> and whose key is <b>key</b>. If the symbol property already has a value, <b>val</b> overwrites the old one. Both <b>symbol</b> and <b>key</b> must not be <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>.</p>
<p>If <b>key</b> is a managing key, <b>val</b> must be a managed object. In this case, the reference count of the old value, if not <code>NULL</code>, is decremented by one, and that of <b>val</b> is incremented by one.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="Set the value of a symbol property.">msymbol_put()</a> returns 0. Otherwise it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="Get the value of a symbol property.">msymbol_get()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga62c1ccf5b0a9924061d3a596ae312527"></a><!-- doxytag: member="symbol.c::msymbol_get" ref="ga62c1ccf5b0a9924061d3a596ae312527" args="(MSymbol symbol, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* msymbol_get </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value of a symbol property. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="Get the value of a symbol property.">msymbol_get()</a> function searches for the value of the symbol property that belongs to <b>symbol</b> and whose key is <b>key</b>. If <b>symbol</b> has such a symbol property, its value is returned. Otherwise <code>NULL</code> is returned.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If an error is detected, <a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="Get the value of a symbol property.">msymbol_get()</a> returns <code>NULL</code> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_SYMBOL</code> </dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="Set the value of a symbol property.">msymbol_put()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gaf0e0b5b8e6e0702ed87df88ad642d7f7"></a><!-- doxytag: member="symbol.c::msymbol_put_func" ref="gaf0e0b5b8e6e0702ed87df88ad642d7f7" args="(MSymbol symbol, MSymbol key, M17NFunc func)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int msymbol_put_func </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a>&nbsp;</td>
          <td class="paramname"> <em>func</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set the value (function pointer) of a symbol property. </p>
<p>The <a class="el" href="group__m17nSymbol.html#gaf0e0b5b8e6e0702ed87df88ad642d7f7" title="Set the value (function pointer) of a symbol property.">msymbol_put_func()</a> function is similar to <a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="Set the value of a symbol property.">msymbol_put()</a> but for setting function pointer <b>func</b> as the property value of <b>symbol</b> for key <b>key</b>.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga9b90027677f183f65d85dac0d7d5bb9c" title="Set the value of a symbol property.">msymbol_put()</a>, <a class="el" href="group__m17nCore.html#ga56e45d7b0345761359001fe038d121ae" title="Wrapper for a generic function type.">M17N_FUNC()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga6446566f8f6a53e825cea16ffbf4c3bd"></a><!-- doxytag: member="symbol.c::msymbol_get_func" ref="ga6446566f8f6a53e825cea16ffbf4c3bd" args="(MSymbol symbol, MSymbol key)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nCore.html#ga2216940cb054b8693aa9d65887bb4b5e">M17NFunc</a> msymbol_get_func </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the value (function pointer) of a symbol property. </p>
<p>The <a class="el" href="group__m17nSymbol.html#ga6446566f8f6a53e825cea16ffbf4c3bd" title="Get the value (function pointer) of a symbol property.">msymbol_get_func()</a> function is similar to <a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="Get the value of a symbol property.">msymbol_get()</a> but for getting a function pointer form the property of symbol <b>symbol</b>.</p>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nSymbol.html#ga62c1ccf5b0a9924061d3a596ae312527" title="Get the value of a symbol property.">msymbol_get()</a> </dd></dl>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ga0346fc05efcccc8f11271b51c0fe3eeb"></a><!-- doxytag: member="symbol.c::Mnil" ref="ga0346fc05efcccc8f11271b51c0fe3eeb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb">Mnil</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "nil". </p>
<p>The symbol <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a> has the name <code>"nil"</code> and, in general, represents <em>false</em> or <em>no</em>. When coerced to "int", its value is zero. <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a> can't have any symbol property. </p>

</div>
</div>
<a class="anchor" id="ga8769a573efbb023b4d77f9d03babc09f"></a><!-- doxytag: member="symbol.c::Mt" ref="ga8769a573efbb023b4d77f9d03babc09f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f">Mt</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "t". </p>
<p>The symbol <a class="el" href="group__m17nSymbol.html#ga8769a573efbb023b4d77f9d03babc09f" title="Symbol whose name is &quot;t&quot;.">Mt</a> has the name <code>"t"</code> and, in general, represents <em>true</em> or <em>yes</em>. </p>

</div>
</div>
<a class="anchor" id="ga60daf7d600a1f487862366a37c171ce5"></a><!-- doxytag: member="symbol.c::Mstring" ref="ga60daf7d600a1f487862366a37c171ce5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5">Mstring</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "string". </p>
<p>The symbol <a class="el" href="group__m17nSymbol.html#ga60daf7d600a1f487862366a37c171ce5" title="Symbol whose name is &quot;string&quot;.">Mstring</a> has the name <code>"string"</code> and is used as an argument of the functions <a class="el" href="group__m17nCharacter.html#ga8c6dde5d282ae96c899f662e1dc17879" title="Define a character property.">mchar_define_property()</a>, etc. </p>

</div>
</div>
<a class="anchor" id="ga6592d4eb3c46fe7fb8993c252b8fedeb"></a><!-- doxytag: member="symbol.c::Msymbol" ref="ga6592d4eb3c46fe7fb8993c252b8fedeb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb">Msymbol</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol whose name is "symbol". </p>
<p>The symbol <a class="el" href="group__m17nSymbol.html#ga6592d4eb3c46fe7fb8993c252b8fedeb" title="Symbol whose name is &quot;symbol&quot;.">Msymbol</a> has the name <code>"symbol"</code> and is used as an argument of the functions <a class="el" href="group__m17nCharacter.html#ga8c6dde5d282ae96c899f662e1dc17879" title="Define a character property.">mchar_define_property()</a>, etc. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
